<template>
    <div class="pagination">
        <b-pagination
            :total="total"
            :current.sync="currentPage"
            :per-page="perPage">

        </b-pagination>
        <b-field class="perPage" label="per Page">
          <b-select v-model="perPage" @change.native="setPerPage($event.target.value)">
            <option value="5">5</option>
            <option value="10">10</option>
            <option value="15">15</option>
            <option value="20">20</option>
          </b-select>
        </b-field>
    </div>
</template>
<script>
export default {
    data(){
        return {
            perPage: 5,
            rangeBefore: 3,
            rangeAfter: 1,
            order: '',
            size: '',
            isSimple: false,
            isRounded: false,
            prevIcon: 'chevron-left',
            nextIcon: 'chevron-right'
        }
    },
    mounted() {
      console.log(this.route)
    },
    watch: {
      $route: {
          immediate: true,
          handler(newVal, oldVal) {
            console.log(newVal.hash)
              if (newVal.hash) {
                  this.current = parseInt(newVal.hash.replace(/\?page/g, ''))
              }
          },
      },
      currentPage(newValue, oldValue) {
        // eslint-disable-next-line no-console
        // this.paginatePage(newValue)
        console.log(newValue)
      },
      // perPage(newValue, oldValue) {
      //   // eslint-disable-next-line no-console
      //   this.paginatePerPage(newValue)
      // },
    },
    methods: {
      setPerPage(value) {
        this.$store.dispatch(`${this.store}/setPerPage`, value)
      }, 
    onClickFirstPage() {
      this.$emit('pagechanged', 1);
    },
    onClickPreviousPage() {
      this.$emit('pagechanged', this.currentPage - 1);
    },
    onClickPage(page) {
      this.$emit('pagechanged', page);
    },
    onClickNextPage() {
      this.$emit('pagechanged', this.currentPage + 1);
    },
    onClickLastPage() {
      this.$emit('pagechanged', this.totalPages);
    }
  },
    computed: {
      currentPage: {
        get() {
          return this.$store.state[this.store]['meta'].current_page
        },
        set(val) {
          this.$store.dispatch(`${this.store}/setCurrentPage`, val)
        },
      },
    startPage() {
      // When on the first page
      if (this.currentPage === 1) {
        return 1;
      }
      // When on the last page
      if (this.currentPage === this.totalPages) {
        return this.totalPages - this.maxVisibleButtons;
      }
      // When in between
      return this.currentPage - 1;
    },
    isInFirstPage() {
      return this.currentPage === 1;
    },
    isInLastPage() {
      return this.currentPage === this.totalPages;
    },
    pages() {
      const range = [];

      for (let i = this.startPage;
        i <= Math.min(this.startPage + this.maxVisibleButtons - 1, this.totalPages);
        i+= 1 ) {
        range.push({
          name: i,
          isDisabled: i === this.currentPage
        });
      }

      return range;
    },
  },
  props: {
    store: {
      type: String,
      required: true
    },
    maxVisibleButtons: {
      type: Number,
      required: false,
      default: 3
    },
    totalPages: {
      type: Number,
      required: true
    },
    total: {
      type: Number,
      required: true
    }
  }
};
</script>